<?php

namespace Aepro;


use Elementor\Widget_Base;
use Elementor\Controls_Manager;
use Elementor\Group_Control_Typography;
use Elementor\Scheme_Typography;
use Aepro\Ae_FACETWP\Skins;
use Aepro\Helper;



class Aepro_FacetWP extends Widget_Base
{
    protected $_has_template_content = false;

    public function get_name() {
        return 'ae-facetwp';
    }

    public function get_title() {
        return __( 'AE - Facet', 'ae-pro' );
    }

    public function get_icon() {
        return 'eicon-toggle';
    }

    public function get_categories() {
        return [ 'ae-template-elements' ];
    }

    protected function _register_skins() {
        $this->add_skin( new Skins\Skin_Checkbox($this));
        $this->add_skin( new Skins\Skin_Radio($this) );
        $this->add_skin( new Skins\Skin_Dropdown($this) );
        $this->add_skin( new Skins\Skin_fSelect($this) );
    }

    protected function _register_controls() {
        $helper = new Helper();

        $this->start_controls_section('general', [
            'label' => __('General', 'ae-pro'),
            'tab'   => Controls_Manager::TAB_CONTENT,
        ]);

        $this->end_controls_section();

        $this->start_controls_section(
            'style',
            [
                'label' => __( 'General', 'ae-pro' ),
                'tab' => Controls_Manager::TAB_STYLE,
            ]
        );

        $this->end_controls_section();

    }
    protected function render()
    {
        parent::render(); // TODO: Change the autogenerated stub
    }

//    protected function _register_controls()
//    {
//        $helper = new Helper();
        //$facet = $helper->get_facetwp_data();
//        $type = [
//            'checkboxes'    =>  __('Checkboxes' , 'ae-pro'),
//            'dropdown'      =>  __('Dropdown' , 'ae-pro'),
//            'fselect'       =>  __('fSelect' , 'ae-pro'),
//            'hierarchy'     =>  __('Hierarchy' , 'ae-po'),
//            'search'        =>  __('Search' , 'ae-pro'),
//            'autocomplete'  =>  __('Autocomplete' , 'ae-pro'),
//            'slider'        =>  __('Slider' , 'ae-pro'),
//            'date_range'    =>  __('Date Range' , 'ae-pro'),
//            'number_range'  =>  __('Number Range' , 'ae-pro'),
//            'proximity'     =>  __('Proximity' , 'ae-pro'),
//            'radio'         =>  __('radio' , 'ae-pro'),
//            'star_rating'   =>  __('Star Rating' , 'ae-pro'),
//        ];
//
//        $this->start_controls_section(
//            'section_general',
//            [
//                'label' => __( 'General', 'ae-pro' ),
//            ]
//        );
//        $this->add_control(
//            'facet_name',
//            [
//                'label' => __( 'Facet', 'ae-pro' ),
//                'type' => Controls_Manager::SELECT,
//                'options' => $facet,
//                'default' => '',
//            ]
//        );
//
//        $this->add_control(
//            'facet_type',
//            [
//                'label' => __( 'Type', 'ae-pro' ),
//                'type' => Controls_Manager::SELECT,
//                'options' => $type,
//                'default' => '',
//            ]
//        );
//
//
//        $this->end_controls_section();
//
//        $this->start_controls_section(
//            'style_section',
//            [
//                'label' => __( 'General', 'ae-pro' ),
//                'tab' => Controls_Manager::TAB_STYLE,
//            ]
//        );
//        $this->add_control(
//            'label_style',
//            [
//                'label' => __( 'Label', 'plugin-name' ),
//                'type' => Controls_Manager::HEADING,
//                'separator' => 'before',
//                'condition' =>  [
//                    'facet_type'    => ['checkboxes' , 'radio'],
//                ],
//            ]
//        );
//        $this->add_group_control(
//            Group_Control_Typography::get_type(),
//            [
//                'name' => 'facet_label_typography',
//                'selectors' => [
//                    '{{WRAPPER}} .facetwp-checkbox',
//                    '{{WRAPPER}} .facetwp-radio',
//                ],
//                'condition' =>  [
//                    'facet_type'    => ['checkboxes' , 'radio'],
//                ],
//            ]
//        );
//
//        $this->add_control(
//            'label_color',
//            [
//                'label' => __( 'Color', 'ae-pro' ),
//                'type' => Controls_Manager::COLOR,
//                'default'   =>  '',
//                'selectors' => [
//                    '{{WRAPPER}} .facetwp-checkbox' => 'color: {{VALUE}}',
//                    '{{WRAPPER}} .facetwp-radio' => 'color: {{VALUE}}',
//                ],
//                'condition' =>  [
//                    'facet_type'    => ['checkboxes' , 'radio'],
//                ],
//            ]
//        );
//
//        $this->add_control(
//            'spacing',
//            [
//                'label' => __( 'Spacing', 'ae-pro' ),
//                'type' => Controls_Manager::SLIDER,
//                'size_units' => [ 'px', '%' ],
//                'range' => [
//                    'px' => [
//                        'min' => 0,
//                        'max' => 100,
//                        'step' => 1,
//                    ],
//                    '%' => [
//                        'min' => 0,
//                        'max' => 100,
//                    ],
//                ],
//                'default' => [
//                    'unit' => 'px',
//                    'size' => 4,
//                ],
//                'selectors' => [
//                    '{{WRAPPER}} .facetwp-checkbox' => 'margin-bottom: {{SIZE}}{{UNIT}};',
//                    '{{WRAPPER}} .facetwp-radio' => 'margin-bottom: {{SIZE}}{{UNIT}};',
//                ],
//                'condition' =>  [
//                    'facet_type'    => ['checkboxes' , 'radio'],
//                ],
//            ]
//        );
//        $this->add_control(
//          'separator',
//          [
//              'label' => __( 'Separator', 'ae-pro' ),
//              'type' => Controls_Manager::SWITCHER,
//              'label_on' => __( 'Show', 'your-plugin' ),
//              'label_off' => __( 'Hide', 'your-plugin' ),
//              'return_value' => 'yes',
//              'default' => 'no',
//              'condition' =>  [
//                  'facet_type'    => ['checkboxes' , 'radio'],
//              ],
//          ]
//        );
//
//        $this->add_control(
//            'separator_size',
//                [
//                    'label' => __( 'Separator Size', 'ae-pro' ),
//                    'type' => Controls_Manager::NUMBER,
//                    'min' => 0,
//                    'max' => 100,
//                    'step' => 1,
//                    'default' => 2,
//                    'selectors' => [
//                        '{{WRAPPER}} .facetwp-checkbox' => 'border-bottom-width:{{VALUE}}px',
//                        '{{WRAPPER}} .facetwp-radio' => 'border-bottom-width:{{VALUE}}px',
//                    ],
//                    'condition' =>  [
//                        'facet_type'    => ['checkboxes' , 'radio'],
//                        'separator'     =>  'yes',
//                    ],
//
//                ]
//        );
//        $this->add_control(
//            'separator_type',
//            [
//                'label' => __( 'Separator Type', 'ae-pro' ),
//                'type' => Controls_Manager::SELECT,
//                'default' => 'solid',
//                'options' => [
//                    'solid'  => __( 'Solid', 'ae-pro' ),
//                    'dashed' => __( 'Dashed', 'ae-pro' ),
//                    'dotted' => __( 'Dotted', 'ae-pro' ),
//                    'double' => __( 'Double', 'ae-pro' ),
//                    'none' => __( 'None', 'ae-pro' ),
//                ],
//                'selectors' => [
//                    '{{WRAPPER}} .facetwp-checkbox' => 'border-bottom-style:{{VALUE}}',
//                    '{{WRAPPER}} .facetwp-radio' => 'border-bottom-style:{{VALUE}}',
//                ],
//                'condition' =>  [
//                    'facet_type'    => ['checkboxes' , 'radio'],
//                    'separator'     =>  'yes',
//                ],
//            ]
//        );
//        $this->add_control(
//            'separator_color',
//            [
//                'label' => __( 'Color', 'ae-pro' ),
//                'type' => Controls_Manager::COLOR,
//                'default'   =>  '',
//                'selectors' => [
//                    '{{WRAPPER}} .facetwp-checkbox' => 'border-bottom-color : {{VALUE}}',
//                    '{{WRAPPER}} .facetwp-radio' => 'border-bottom-color : {{VALUE}}',
//                ],
//                'condition' =>  [
//                    'facet_type'    => ['checkboxes' , 'radio'],
//                ],
//            ]
//        );
//
//        $this->add_control(
//            'left_indent',
//            [
//                'label' => __( 'Indent', 'ae-pro' ),
//                'type' => Controls_Manager::SLIDER,
//                'size_units' => [ 'px', '%' ],
//                'range' => [
//                    'px' => [
//                        'min' => 0,
//                        'max' => 100,
//                        'step' => 1,
//                    ],
//                    '%' => [
//                        'min' => 0,
//                        'max' => 100,
//                    ],
//                ],
//                'default' => [
//                    'unit' => 'px',
//                    'size' => 20,
//                ],
//                'selectors' => [
//                    '{{WRAPPER}} .facetwp-checkbox img' => 'margin-right: {{SIZE}}{{UNIT}};',
//                    '{{WRAPPER}} .facetwp-radio img' => 'margin-right: {{SIZE}}{{UNIT}};',
//                ],
//                'condition' =>  [
//                    'facet_type'    => ['checkboxes' , 'radio'],
//                ],
//            ]
//        );
//
//
//        $this->add_responsive_control(
//            'box_size',
//            [
//                'label' => __( 'Box Size', 'ae-pro' ),
//                'type' => Controls_Manager::SLIDER,
//                'size_units' => [ 'px', '%' ],
//                'range' => [
//                    'px' => [
//                        'min' => 0,
//                        'max' => 100,
//                        'step' => 1,
//                    ],
//                    '%' => [
//                        'min' => 0,
//                        'max' => 100,
//                    ],
//                ],
//                'default' => [
//                    'unit' => 'px',
//                    'size' => 14,
//                ],
//                'selectors' => [
//                    '{{WRAPPER}} .facetwp-checkbox img' => 'width: {{SIZE}}{{UNIT}}; height : {{SIZE}}{{UNIT}}',
//                    '{{WRAPPER}} .facetwp-radio' => 'background-size: {{SIZE}}{{UNIT}};',
//                ],
//                'condition' =>  [
//                    'facet_type'    => ['checkboxes' , 'radio'],
//                ],
//            ]
//        );
//
//        $this->add_control(
//            'counter_style',
//            [
//                'label' => __( 'Counter', 'plugin-name' ),
//                'type' => Controls_Manager::HEADING,
//                'separator' => 'before',
//                'condition' =>  [
//                    'facet_type'    => ['checkboxes' , 'radio'],
//                ],
//            ]
//        );
//        $this->add_group_control(
//            Group_Control_Typography::get_type(),
//            [
//                'name' => 'counter_typography',
//                'scheme' => Scheme_Typography::TYPOGRAPHY_1,
//                'selector' => [
//                    '{{WRAPPER}} .facetwp-checkbox .facetwp-counter',
//                    '{{WRAPPER}} .facetwp-radio .facetwp-counter',
//                ],
//                'condition' =>  [
//                    'facet_type'    => ['checkboxes' , 'radio'],
//                ],
//            ]
//        );
//
//        $this->add_control(
//            'counter_color',
//            [
//                'label' => __( 'Color', 'ae-pro' ),
//                'type' => Controls_Manager::COLOR,
//                'default'   =>  '',
//                'selectors' => [
//                    '{{WRAPPER}} .facetwp-checkbox .facetwp-counter' => 'color: {{VALUE}}',
//                    '{{WRAPPER}} .facetwp-radio .facetwp-counter' => 'color: {{VALUE}}',
//                ],
//                'condition' =>  [
//                    'facet_type'    => ['checkboxes' , 'radio'],
//                ],
//            ]
//        );
//        $this->end_controls_section();
//    }
//
//    function checkbox_output( $output, $params ) {
//         if ( 'checkboxes' == $params['facet']['type'] ) {
//             //echo '<pre>'; print_r($params); echo '</pre>';
//             $output = '';
//             $values = (array) $params['values'];
//             $selected_values = (array) $params['selected_values'];
//             $facet = $params['facet'];
//             $soft_limit = empty( $facet['soft_limit'] ) ? 0 : (int) $facet['soft_limit'];
//             $key = 0;
//             foreach ( $values as $result ){
//                 if ( 0 < $soft_limit && $key == $soft_limit ) {
//                     $output .= '<div class="facetwp-overflow facetwp-hidden">';
//                 }
//                 $selected = in_array( $result['facet_value'], $selected_values ) ? ' checked' : '';
//                 $selected .= ( 0 == $result['counter'] && '' == $selected ) ? ' disabled' : '';
//                 $output .= '<div class="facetwp-checkbox' . $selected . '" data-value="' . esc_attr( $result['facet_value'] ) . '">';
//                 $src = !empty($selected)? AE_PRO_URL.'includes/assets/images/checkbox-on.png' : AE_PRO_URL.'includes/assets/images/checkbox.png';
//                 $output .= '<img src='.$src.'>';
//                 $output .= esc_html( $result['facet_display_value'] );
//                 $output.='<span class="facetwp-counter"> ('. $result['counter'] . ') </span>';
//                 $output .= '</div>';
//             }
//             if ( 0 < $soft_limit && $soft_limit <= $key ) {
//                 $output .= '</div>';
//                 $output .= '<a class="facetwp-toggle">' . __( 'See {num} more', 'fwp-front' ) . '</a>';
//                 $output .= '<a class="facetwp-toggle facetwp-hidden">' . __( 'See less', 'fwp-front' ) . '</a>';
//             }
//
//         }
//         return $output;
//    }
//
//    protected function render( )
//    {
//        add_filter( 'facetwp_facet_html',[$this , 'checkbox_output'], 10, 2 );
//        $settings = $this->get_settings();
//        $facet_name = $settings['facet_name'];
//        if(!empty($facet_name)){
//            echo facetwp_display( 'facet', $facet_name);
//        }
//        //remove_filter('facetwp_facet_html' , 'checkbox_output' , '10' );
//    }
}
\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Aepro_FacetWP() );